.list
;*************************************************************
;
;
;******avr_LED.asm**********************************************
;
;

;

;
;*************************************************************
;
;POPIS:
;PO RESETE SA ROZOSVIETIA LEDKY NA CCA 1 S
;V TOMTO CASE UZ JE MOZNE POMOCOU TLACITKA SW2 VOLIT 
;JEDEN ZO STYROCH PROGRAMOV
;

;------------------------------------------------------------------
.nolist
.INCLUDE "1200def.inc"  ;pouziva 1200-kove nastavenia v 1200def.inc 
.list			
;-------------------------------------------------------------------
.CSEG			;zaciatok programu
	.def a=r16	;prvy register = "a"
	.def b=r17	;druhy register = "b"
	.def cnt=r18	;register r2 je pocitaci register
	.def temp=r19	;temp je odkadaci register
	.equ globint=7
	.equ pb = $18	;pomenovanie pre portb je pb
	.equ t=6	;definuje bit T
	.equ poc_op=$4
	.equ full=$0ff
	.equ zero=0
	.equ I=7


;**************************************************************

	.org 0x00	;zaciatok je na adrese 00hexa

begin: 	rjmp reset
	rjmp sw2int	;prerusenie od sw2
	rjmp ctint	;prerusenie od casovaca
	reti		;prerusenie od komparatora
	
ctint:	;preruseni od citaca nastane cca 1/4 s
;	sbrc r1,0	;ak je nastaveny r1=1, tak sa vrati, ale pred tym
;	rjmp styri	;nastavi bit T
	clz		;vynuluje priznak nuly
	dec cnt		;odpocita  cnt 
	breq styri
	reti
styri:			; ak je odpocitane 4 prerusenia
	bset t
	clz
	reti

sw2int:	;prerusenie od sw2
	;v registri temp ma pocet stlaceni sw2
	bclr globint	;zakaz preruseni
	bset t		;nastavi sa priznak T, ten je testovany
			;v nasledujucom programe
	in r0,tccr0	;odlozi obsah registra tccr0
	ldi b,0
	out tccr0,b	;zastavi pocitanie casu
	out tcnt0,b	;vynuluje pocitadlo
	inc temp
	ldi b,4
	cp b,temp
	brne sw2end
	ldi temp,0
sw2end:	out tccr0,r0	;obnovi pocitanie casu
	bset globint	;opat povoli prerusenie
	rjmp loop

;*************** uvod **************************************	

reset:	;nastavenie pociatocnych podmienok

	ldi cnt,poc_op	; pocita 4 prerusenia	
	bclr t  	; vynuluje bit T pre pomocne nastavenia	
	bclr globint	;globalny zakaz preruseni
	ldi b,full	
	out ddrb,b	; nastavi vsetky bity ddrb registra=
			; pb je output
	ldi b,0
	out portb,b	; vynuluj portb
	mov temp,b	; vynuluje temporary register
	mov r1,b	; vynuluje r1, ten sa pouziva pri kontrole
			; preruseni
	cbi ddrd,pd2	; priprav pd2 ako vstup (je to externy INT0)
	sbi portd,pd2	; pri uzemneni dava prud 20mA

;nastavenie casovaca na cca 1s
	ldi b,0
	out tcnt0,b	; vynuluje sa citac
	ldi b,2
	out $39,b	; povoluje sa prerusenie od casovaca 
	ldi b,5	
	out tccr0,b	; nastavi sa delicka na clk / 1024
				; a zaroven sa citanie spusti
	
; ak je delicka pre citac nastavena na 1024 a mame 8 bitovy citac, 
; tak dostaneme prerusenie cca 4Hz, toto mozeme vyuzit pre blikanie diod
; pri preteceni ff->00 citaca sa vyvola prerusenie

; nastavenie prerusovacich urovni na nizku /hladinove riadenie (isc00 a 
; isc01 v registri MCUCR su 0)

	ldi b,2
	out mcucr,b	;prerusenie reaguje na zostupnu hranu 1-0

; povolenie prerusenia od spinaca sa zacne az po rozsvieteni lediek

	ldi a,0x0ff	; napln a 0b11111111 a teda led  rozsvieti
	out pb,a
	
	ldi b,0b01000000; to je povolenie prerusenia od casovaca
	out gimsk,b	
					
	bset globint	; povoli globalne prerusenia

	; teraz caka na prerusenie od sw2
loop:	brtc loop	; slucka dokial nebude T=1
	bclr t	

	;ak do sekundy nestlacis tlacidlo sw2, ide automaticky na prvy program
	
	cpi temp,3	; porovna temp, ak je =3 ide na program 4-ty
	breq stvrty
	cpi temp,2
	breq treti
	cpi temp,1
	breq druhy

;-------------------------------------------------------------------------

	;prvy podprogram
prvy:	bclr 0
	ldi a,1		; do a da 00000001
return:	out pb,a	; zapise na pb a
	ldi cnt,poc_op
loop1:	brtc loop1	; slucka dokial nebude T=1
	bclr t	
	rol a		; rotuje a / s frekvenciou cca 1Hz
	rjmp return	; beha stale dookola
	
;------------------------------------------------------------------------	

	;druhy podprogram
druhy:	ldi a,zero	;druhy podprogram, vsetky led blikaju
druhyI:	bclr t		;vynuluj T
	ldi cnt,1	;ukazuje preruseniu, ze ide od podprog. druhy
			;budu blikat 2x/sec
obskok:	out pb,a	
	brtc obskok
	com a		;inak zneguje a
	rjmp druhyI	;a posle ho na port pb

;-----------------------------------------------------------------------

treti:	;podprogram pre rozsvecovanie svetiel Knight Rider
	bclr 0
	bclr t
	ldi b,1
	ldi a,0		;pracuje na zaklade posunu a pricitania 
obskI:	ldi cnt,1	;registra a
	add a,b		;tu je pricitanie
obskII:	out pb,a
	brtc obskII
	bclr t
	cpi a,$ff
	breq oo
	lsl a		;tu je posun dolava	 		
	rjmp obskI
	;doposial bol pohyb dolava
	;teraz nasleduje pohyb doprava
oo:	bclr t
obsk3:	ldi cnt,1
	lsr a
obsk4:	out pb,a
	brtc obsk4
	bclr t
	brcs obsk3 
	rjmp treti
;------------------------------------------------------------------------
stvrty:	;vyberie z EEPREOM udaje a posle ich na pb. ak je v eeprom znak $10
	;vracia sa na zaciatok
	bclr t
aa:	ldi b,0
ac:	out eear,b
	sbi eecr,eere
	in a, eedr
	cpi a,$10
	breq aa
	out pb,a
	ldi cnt,4
ab:	brtc ab
	bclr t
	inc b
	cpi b,$40	;na zaciatok sa vracia tiez, ak
	breq aa		;skonci pamat eeprom (64B)
	rjmp ac
.exit		